#ifndef __GEEKAMP_H
#define __GEEKAMP_H

#include <windows.h>
#include <lsapi\lsapi.h>
#include <lsapi\lswinbase.h>
#include <sstream>
#include "winamp.h"

#define WIN32_LEAN_AND_MEAN
#define MAX_LINE_LENGTH 4096


class Geekamp : public Window {
private:
	char names[MAX_LINE_LENGTH];
	char command[MAX_LINE_LENGTH];
	char szAmpPath[MAX_LINE_LENGTH];
	char buffer[MAX_LINE_LENGTH];
	BOOL WinampStartNormal;
	int position;
	char song_title[MAX_LINE_LENGTH], *p, fileProp[MAX_LINE_LENGTH], chan[7];
	int bitrate, samplerate, channels;
	BOOL PlayNotOpen, PlayPauseNotOpen, PlaylistNotOpen, PrefsNotOpen, LoadFileNotOpen, ShowNotOpen, LibraryNotOpen;
public:
	Geekamp(HWND parentWnd, int& code);
	~Geekamp();
	HWND GetWinampWnd(void);
	void WinampMessage(const int);
	void WinampOpen(void);
	void MovePositive(int);
	void MoveNegative(int);
	void BangAmp_TimeRemaining();
	void BangAmp_Hide();
	void BangAmp_Display();
	void BangAmp_AddSong(LPCSTR);
	void BangAmp_PlayPause();
	void BangAmp_FileInfo();
	void BangAmp_HighPriority();
	void BangAmp_Rew();
	void BangAmp_Stop();
	void BangAmp_About();
	void BangAmp_DoubleSize();
	void BangAmp_EasyMove();
	void BangAmp_EditID3();
	void BangAmp_Eq();
	void BangAmp_Ffwd5s();
	void BangAmp_Jump10Back();
	void BangAmp_Jump10Fwd();
	void BangAmp_JumpToFile();
	void BangAmp_JumpToTime();
	void BangAmp_ListEnd();
	void BangAmp_ListStart();
	void BangAmp_LoadDir();
	void BangAmp_LoadFile();
	void BangAmp_MainMenuPopup();
	void BangAmp_Next();
	void BangAmp_OnTop();
	void BangAmp_OpenLoc();
	void BangAmp_Pause();
	void BangAmp_Play();
	void BangAmp_Playlist();
	void BangAmp_Power();
	void BangAmp_Prefs();
	void BangAmp_Prev();
	void BangAmp_ReloadSkin();
	void BangAmp_Repeat();
	void BangAmp_Rewd5s();
	void BangAmp_SelectSkin();
	void BangAmp_SetPanning(LPCSTR);
	void BangAmp_SetVolume(LPCSTR);
	void BangAmp_ShadeBoth();
	void BangAmp_ShadePlaylist();
	void BangAmp_Show();
	void BangAmp_Shuffle();
	void BangAmp_StartPlugin();
	void BangAmp_StopFade();
	void BangAmp_StopPlugin();
	void BangAmp_ToggleBrowser();
	void BangAmp_VisSetup();
	void BangAmp_VolumeDown();
	void BangAmp_VolumeUp();
	void BangAmp_WindowShade();
	void BangAmp_PowerOn();
	void BangAmp_PowerOff();
	void BangAmp_Ffwd10s();
	void BangAmp_Ffwd20s();
	void BangAmp_Rew10s();
	void BangAmp_Rew20s();
	void BangAmp_Restart();
	void BangAmp_MovePosition(LPCSTR);
	void BangAmp_LoadEQPreset();
	void BangAmp_TimeElapsed();
	void BangAmp_LS2K();
	void BangAmp_Video();
	void BangAmp_Library();
	
private:
	virtual void windowProc(Message& message);
	void onEndSession(Message& message);
	void onGetRevId(Message& message);
	void onSysCommand(Message& message);
};

void BangAmp_LibraryFunction(HWND, LPCSTR);
void BangAmp_VideoFunction(HWND, LPCSTR);
void BangAmp_LS2KFunction(HWND, LPCSTR);
void BangAmp_TimeElapsedFunction(HWND, LPCSTR);
void BangAmp_TimeRemainingFunction(HWND, LPCSTR);
void BangAmp_HideFunction(HWND, LPCSTR);
void BangAmp_DisplayFunction(HWND, LPCSTR);
void BangAmp_AddSongFunction(HWND, LPCSTR);
void BangAmp_PlayPauseFunction(HWND, LPCSTR);
void BangAmp_LoadEQPresetFunction(HWND, LPCSTR);
void BangAmp_MovePositionFunction(HWND, LPCSTR);
void BangAmp_Ffwd10sFunction(HWND, LPCSTR);
void BangAmp_Ffwd20sFunction(HWND, LPCSTR);
void BangAmp_Rew10sFunction(HWND, LPCSTR);
void BangAmp_Rew20sFunction(HWND, LPCSTR);
void BangAmp_PowerOnFunction(HWND, LPCSTR);
void BangAmp_PowerOffFunction(HWND, LPCSTR);
void BangAmp_FileInfoFunction(HWND, LPCSTR);
void BangAmp_HighPriorityFunction(HWND, LPCSTR);
void BangAmp_AboutFunction(HWND, LPCSTR);
void BangAmp_DoubleSizeFunction(HWND, LPCSTR);
void BangAmp_EasyMoveFunction(HWND, LPCSTR);
void BangAmp_EditID3Function(HWND, LPCSTR);
void BangAmp_EqFunction(HWND, LPCSTR);
void BangAmp_Ffwd5sFunction(HWND, LPCSTR);
void BangAmp_Jump10BackFunction(HWND, LPCSTR);
void BangAmp_Jump10FwdFunction(HWND, LPCSTR);
void BangAmp_JumpToFileFunction(HWND, LPCSTR);
void BangAmp_JumpToTimeFunction(HWND, LPCSTR);
void BangAmp_ListEndFunction(HWND, LPCSTR);
void BangAmp_ListStartFunction(HWND, LPCSTR);
void BangAmp_LoadDirFunction(HWND, LPCSTR);
void BangAmp_LoadFileFunction(HWND, LPCSTR);
void BangAmp_MainMenuPopupFunction(HWND, LPCSTR);
void BangAmp_NextFunction(HWND, LPCSTR);
void BangAmp_OnTopFunction(HWND, LPCSTR);
void BangAmp_OpenLocFunction(HWND, LPCSTR);
void BangAmp_PauseFunction(HWND, LPCSTR);
void BangAmp_PlayFunction(HWND, LPCSTR);
void BangAmp_PlaylistFunction(HWND, LPCSTR);
void BangAmp_PowerFunction(HWND, LPCSTR);
void BangAmp_PrefsFunction(HWND, LPCSTR);
void BangAmp_PrevFunction(HWND, LPCSTR);
void BangAmp_ReloadSkinFunction(HWND, LPCSTR);
void BangAmp_RepeatFunction(HWND, LPCSTR);
void BangAmp_Rewd5sFunction(HWND, LPCSTR);
void BangAmp_SelectSkinFunction(HWND, LPCSTR);
void BangAmp_SetPanningFunction(HWND, LPCSTR);
void BangAmp_SetVolumeFunction(HWND, LPCSTR);
void BangAmp_ShadeBothFunction(HWND, LPCSTR);
void BangAmp_ShadePlaylistFunction(HWND, LPCSTR);
void BangAmp_ShowFunction(HWND, LPCSTR);
void BangAmp_ShuffleFunction(HWND, LPCSTR);
void BangAmp_StartPluginFunction(HWND, LPCSTR);
void BangAmp_StopFadeFunction(HWND, LPCSTR);
void BangAmp_StopPluginFunction(HWND, LPCSTR);
void BangAmp_ToggleBrowserFunction(HWND, LPCSTR);
void BangAmp_VisSetupFunction(HWND, LPCSTR);
void BangAmp_VolumeDownFunction(HWND, LPCSTR);
void BangAmp_VolumeUpFunction(HWND, LPCSTR);
void BangAmp_WindowShadeFunction(HWND, LPCSTR);
void BangAmp_StopFunction(HWND, LPCSTR);
void BangAmp_RewFunction(HWND, LPCSTR);
void BangAmp_RestartFunction(HWND, LPCSTR);

template<typename T>
T Converter(LPCSTR str)
{
	std::istringstream converter(str);
	T val;
	converter >> val;
	return val;
}


extern "C"
{
	__declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
	__declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}

#endif